static char rcsid[] = "$Header: /home/cvsroot/xmimonc/load.c,v 1.1.1.1 2001/11/17 16:30:04 kelly Exp $";
/*
 * $Header: /home/cvsroot/xmimonc/load.c,v 1.1.1.1 2001/11/17 16:30:04 kelly Exp $
 *	
 * (c) 2001 Andreas Keldenich <kelly@myfoo.de>
 *
 * $Log: load.c,v $
 * Revision 1.1.1.1  2001/11/17 16:30:04  kelly
 * Initial revision
 *
 */

#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>

#include "xmimonc.h"


static int load[LOAD_HISTORY];
static int load_max;
static GC gc_fg;
static GC gc_bg;
static GC gc_line;
static Pixmap pixmap;


void LoadInit(Widget da)
{
  int i;
  XGCValues gcv;
  String color = "red";
  Colormap cmap = DefaultColormapOfScreen(XtScreen(da));
  XColor col, unused;
  Display *display = XtDisplay(da);
  Dimension w = 100, h = 100;
  
  for (i = 0; i < LOAD_HISTORY; i++)
    load[i] = 0;
  
  gcv.foreground = BlackPixelOfScreen(XtScreen(da));
  gc_fg = XCreateGC(display, RootWindowOfScreen(XtScreen(da)), GCForeground, &gcv);
  gcv.foreground = WhitePixelOfScreen(XtScreen(da));
  gc_bg = XCreateGC(display, RootWindowOfScreen(XtScreen(da)), GCForeground, &gcv);
  gcv.foreground = BlackPixelOfScreen(XtScreen(da));
  gc_line = XCreateGC(display, RootWindowOfScreen(XtScreen(da)), GCForeground, &gcv);
  if (XAllocNamedColor(display, cmap, color, &col, &unused))
    XSetForeground(display, gc_line, col.pixel);
  
  pixmap = XCreatePixmap(XtDisplay(da), RootWindowOfScreen(XtScreen(da)), 
  		w, h, DefaultDepthOfScreen(XtScreen(da)));
}


void LoadStore(int bi, int bo)
{
  int i, max = 0;
  
  /* shift all values one further */
  for (i = LOAD_HISTORY - 1; i > 0; i--)
  {
    if (load[i] > max)
      max = load[i];
    load[i] = load[i-1];
  }
  
  load[0] = bi + bo;
}


void LoadUpdate(FormData *form_data)
{
  Dimension w, h;
  Position x, i = 0, pix = 10;
  int max = 0, j, max_kb;
  Widget da = form_data->da_load;
  Display *display = XtDisplay(da);
  Screen *screen = XtScreen(da);
  Window window = XtWindow(da);
  double p;
  
  XtVaGetValues(da,
  	XmNwidth,	&w,
	XmNheight,	&h,
	NULL);
  
  /* find max load in window */
  for (i = 0; i < w; i++)
    if (load[i] > max)
      max = load[i];
  max_kb = max / 1024 + 1;
  
  XFillRectangle(display, pixmap, gc_bg, 0, 0, w, h);
  i = w-1;
  for (x = 0; x < w; x++)
  {
    p = (double) load[i] / (double) (max_kb * 1024) * (double) h;
    pix = (int) p;
    
    XDrawLine(display, pixmap, gc_fg, x, h, x, h-pix); /* draw load */
    /* XDrawLine(display, pixmap, gc_bg, x, h-pix-1, x, 1); */ /* clear rest */
    
    i--;
  }
  
  /* draw the lines */
  for (i = 1; i < max_kb; i++)
  {
    p = (double) (i* 1024) / (double) (max_kb * 1024) * (double) h;
    pix = (int) p;
    XDrawLine(display, pixmap, gc_line, 0, h-pix, w-1, h-pix); 
  }
  XCopyArea(display, pixmap, window, gc_fg, 0, 0, w, h, 0, 0);
}


void LoadExposeCB(Widget da, XtPointer client_data, XtPointer call_data)
{
  XmDrawingAreaCallbackStruct *cbs = (XmDrawingAreaCallbackStruct *) call_data;
  FormData *form_data = (FormData *) client_data;
  
  LoadUpdate(form_data);
}


void LoadResizeCB(Widget da, XtPointer client_data, XtPointer call_data)
{
  XmDrawingAreaCallbackStruct *cbs = (XmDrawingAreaCallbackStruct *) call_data;
  FormData *form_data = (FormData *) client_data;
  Dimension w, h;
  
  XtVaGetValues(da,
  	XmNwidth,	&w,
	XmNheight,	&h,
	NULL);
  
  pixmap = XCreatePixmap(XtDisplay(da), RootWindowOfScreen(XtScreen(da)), 
  		w, h, DefaultDepthOfScreen(XtScreen(da)));
}

