/* $Header: /home/cvsroot/xmimonc/xmimonc.h,v 1.1.1.1 2001/11/17 16:30:04 kelly Exp $
 *	
 * (c) 2001 Andreas Keldenich <kelly@myfoo.de>
 *
 * $Log: xmimonc.h,v $
 * Revision 1.1.1.1  2001/11/17 16:30:04  kelly
 * Initial revision
 *
 */
 
#ifndef __XMIMONC_H__
#define __XMIMONC_H__

#include <Xm/Xm.h>

#define	APPCLASS	"XMimonc"

/* compiled in defaults */

#define	HOST			"igate"
#define PORT			5000
#define MAX_CONNECT_RETRY	5

#define STATUS_OFFLINE		0
#define STATUS_ONLINE		1
#define STATUS_NO_CONNECT	2
#define STATUS_UNKNOWN		3

#define LOAD_HISTORY		2000


/* definitions */

typedef struct _Channel
{ 
  /* definition of an imoncd channel */
  int status;
  int hup_timeout;	/* hang up time out in seconds */
  long bi;		/* bytes in */
  long bo;		/* bytes out */
  char ip[16];		/* ip v4 only for now. */
  char circuit[50];	/* the called cricuit */
  char device[20];	/* the device */
  char direction[10];	/* direction of the call */
} Channel;


typedef struct _FormData
{
  /* Motif stuff and widgets */
  Widget app_shell;
  XtAppContext app;
  Widget menu;
  Widget form;
  Widget sep;
  Widget label_status, frame_status;
  Widget label_status_led, frame_status_led;
  Widget rc_data, rc_labels;
  Widget label_cpu, label_cpu_data;
  Widget label_ip, label_ip_data;
  Widget label_bytes, label_bytes_data;
  Widget da_load, frame_load;
  
  
  Pixmap online, offline, no_connect, unknown, icon;
  
  /* data */
  int fd;		/* imonc socket file descriptor */
  XtInputId cbid;	/* call back input id for socket */
  Channel *channels;	/* the channels (isdn) */
  int channel_count;	/* number of channels */
} FormData;


typedef struct _menu_item 
{
  char *label;			/* the label for the item		*/
  Widget widget;		/* widget				*/
  WidgetClass *class;		/* pushbutton, label, separator...	*/
  char mnemonic;		/* mnemonic; NULL if none		*/
  char *accelerator;		/* accelerator; NULL if none 		*/
  char *accel_text;		/* to be converted to compound string 	*/
  void (*callback)();		/* routine to call; NULL if none 	*/
  XtPointer callback_data;	/* client_data for callback() 		*/
  struct _menu_item *subitems;	/* pullright menu items, if not NULL 	*/
} MenuItem;


/* prototypes */

void XmiExit(Widget, XtPointer, XtPointer);
void XmiStatus(char*, ...);
void XmiStatusLed(int);
void XmiSetTitle(char*);

void UtilUpdateLabel(Widget, char*, ...);

int ImoncDisconnect(FormData*);
char *ImoncCommand(char*, ...);
void ImoncTimeOutConnect(XtPointer, XtIntervalId*);

void IconWindow(FormData*);

void LoadInit(Widget);
void LoadStore(int, int);
void LoadUpdate(FormData*);
void LoadExposeCB(Widget, XtPointer, XtPointer);
void LoadResizeCB(Widget, XtPointer, XtPointer);


#endif /* __XCCSTAT_H__ */
